package com.zsc.edu.gateway.modules.system.entity;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.JavaType;
import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.apache.ibatis.type.JdbcType;

/**
 * 菜单
 *
 * @author harry yao
 */
@Getter
@Setter
@EqualsAndHashCode(callSuper = false)
@TableName("sys_menu")
public class Menu extends BaseEntity {
    /**
     * 父菜单id
     */
    private Long pid;
    /**
     * 菜单类型
     */
    private Type type;
    /**
     * 路由名称
     */
    private String name;
    /**
     * 菜单路径
     */
    private String path;
    /**
     * 菜单名称（语言包键名）
     */
    private String locale;
    /**
     * 菜单icon
     */
    private String icon;
    /**
     * 是否需要登录鉴权
     */
    private Boolean requiresAuth=true;
    /**
     * 是否隐藏菜单
     */
    private Boolean hideInMenu=false;
    /**
     * 排序
     */
    private Integer menuOrder;
    /**
     * 访问权限，使用","隔开的权限字符串
     */
    private String permissions;

    /**
     * 权限字符串
     */
    private String authority;

    public Menu(Long pid, Type type, String name, String path, String locale, String icon, Boolean requiresAuth, Boolean hideInMenu, Integer order, String authority) {
        this.pid = pid;
        this.type = type;
        this.name = name;
        this.path = path;
        this.locale = locale;
        this.icon = icon;
        this.requiresAuth = requiresAuth;
        this.hideInMenu = hideInMenu;
        this.menuOrder = order;
        this.authority = authority;
    }

    /**
     * 菜单类型
     */
    @Getter
    @AllArgsConstructor
    public enum Type {
        /**
         * 页面
         */
        PAGE(0),
        /**
         * 按钮
         */
        BUTTON(1);

        @EnumValue
        private final int value;
    }
}