package com.zsc.edu.gateway.modules.system.service.impl;

import com.zsc.edu.gateway.modules.system.entity.Menu;
import com.zsc.edu.gateway.modules.system.entity.Role;
import com.zsc.edu.gateway.modules.system.entity.RoleMenu;
import com.zsc.edu.gateway.modules.system.repo.RoleMenuRepository;
import com.zsc.edu.gateway.modules.system.service.MenuService;
import com.zsc.edu.gateway.modules.system.service.RoleService;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

@SpringBootTest
class MenuServiceImplTest {

    @Autowired
    private MenuService menuService;

    @Autowired
    private RoleService roleService;

    @Autowired
    private RoleMenuRepository roleMenuRepository;

    @Test
    public void insertRootMenu() {
        Menu dashboard = new Menu(null, Menu.Type.PAGE, "Dashboard", "/dashboard", "dashboard", "icon-dashboard", true, false, 1, "dashboard");
        Menu system = new Menu(null, Menu.Type.PAGE,  "System", "/system", "menu.system", "icon-computer", true, false, 2, "system");
        Menu user = new Menu(null, Menu.Type.PAGE,  "User", "/user", "menu.user", "icon-user", true, false, 3, "user");
        Menu message = new Menu(null,  Menu.Type.PAGE, "Message", "/message", "消息管理", "icon-message", true, false, 4, "message");
        menuService.saveBatch(List.of(dashboard, system, user, message));
        Menu workplace = new Menu(dashboard.getId(),  Menu.Type.PAGE, "Workplace", "workplace", "工作台", "icon-dashboard", true, false, 1, "dashboard:workplace");
        Menu role = new Menu(system.getId(),  Menu.Type.PAGE, "Role", "role", "角色管理", null, true, false, 1, "system:role");
        Menu roleDelete = new Menu(role.getId(), Menu.Type.BUTTON,   "roleDelete", null, "角色删除", null, true, false, 1, "system:role:delete");
        Menu dept = new Menu(system.getId(),  Menu.Type.PAGE, "Dept", "dept", "部门管理", null, true, false, 2, "system:dept");
        Menu users = new Menu(system.getId(),  Menu.Type.PAGE, "User", "user", "用户管理", null, true, false, 3, "system:user");
        Menu authority = new Menu(system.getId(),  Menu.Type.BUTTON,  "Authority", "authority", "权限管理", null, true, false, 4, "system:authority");
        Menu menu = new Menu(system.getId(),  Menu.Type.PAGE, "Menu", "menu", "菜单管理", null, true, false, 5, "system:menu");
        Menu notice = new Menu(message.getId(), Menu.Type.PAGE, "Notice", "notice", "通知管理", null, true, false, 1, "message:notice");
        Menu bulletin = new Menu(message.getId(), Menu.Type.PAGE, "Bulletin", "bulletin", "公告管理", null, true, false, 2, "message:bulletin");
        menuService.saveBatch(List.of(workplace, roleDelete, dept, users, authority, menu, notice, bulletin));
        Menu roleCreate = new Menu(role.getId(), Menu.Type.BUTTON,  "roleCreate", null, "角色新增", null, true, false, 1, "system:role:create");
        Menu roleUpdate = new Menu(role.getId(),  Menu.Type.BUTTON,  "roleUpdate", null, "角色修改", null, true, false, 1, "system:role:update");
        Menu roleQuery = new Menu(role.getId(),  Menu.Type.BUTTON,  "roleQuery", null, "角色查询", null, true, false, 1, "system:role:query");
        Menu deptSave = new Menu(dept.getId(),  Menu.Type.BUTTON,  "deptCreate", null, "部门新增", null, true, false, 1, "system:dept:create");
        Menu deptUpdate = new Menu(dept.getId(),  Menu.Type.BUTTON,  "deptUpdate", null, "部门修改", null, true, false, 1, "system:dept:update");
        Menu deptQuery = new Menu(dept.getId(),  Menu.Type.BUTTON,  "deptQuery", null, "部门查询", null, true, false, 1, "system:dept:query");
        Menu deptDelete = new Menu(dept.getId(),  Menu.Type.BUTTON,  "deptDelete", null, "部门删除", null, true, false, 1, "system:dept:delete");
        Menu userSave = new Menu(dept.getId(),  Menu.Type.BUTTON,  "userCreate", null, "用户新增", null, true, false, 1, "system:user:create");
        Menu userUpdate = new Menu(dept.getId(),  Menu.Type.BUTTON,  "userUpdate", null, "用户修改", null, true, false, 1, "system:user:update");
        Menu userQuery = new Menu(dept.getId(),  Menu.Type.BUTTON,  "userQuery", null, "用户查询", null, true, false, 1, "system:user:query");
        Menu userDelete = new Menu(dept.getId(),  Menu.Type.BUTTON,  "userDelete", null, "用户删除", null, true, false, 1, "system:user:delete");
        Menu menuSave = new Menu(menu.getId(),  Menu.Type.BUTTON,  "menuCreate", null, "菜单新增", null, true, false, 1, "system:menu:create");
        Menu menuUpdate = new Menu(menu.getId(),  Menu.Type.BUTTON,  "menuUpdate", null, "菜单修改", null, true, false, 1, "system:menu:update");
        Menu menuQuery = new Menu(menu.getId(),  Menu.Type.BUTTON,  "menuQuery", null, "菜单查询", null, true, false, 1, "system:menu:query");
        Menu menuDelete = new Menu(menu.getId(),  Menu.Type.BUTTON,  "menuDelete", null, "菜单删除", null, true, false, 1, "system:menu:delete");
        menuService.saveBatch(List.of(roleCreate, roleUpdate, roleQuery, deptSave, deptUpdate, deptQuery, deptDelete, userSave, userUpdate, userQuery, userDelete, menuSave, menuUpdate, menuQuery, menuDelete));
    }

    @Test
    public void test() {
        Role admin = roleService.lambdaQuery().eq(Role::getName, "admin").one();
        menuService.list().forEach(menu -> {
            roleMenuRepository.insert(new RoleMenu(admin.getId(), menu.getId()));
        });
    }

}